/* declarations of the machine structure -- architecture specificities */

typedef struct machnode *machine;

struct machnode {
  int type;		/* type for the FELL system */
  char *print;		/* string for the FELL system */
  int id;		/* unique id */
  int address;		/* address in the soup */
  int len;		/* allocated size in the soup */
  int genid;		/* genome id of this machine */
  int pargenid;		/* genome id of parent of this machine */
  int spawned;		/* number this machine has spawned */
  int pc;		/* machine pc */
  int alloc_lo;		/* first byte of allocated (-1 = none) */
  int alloc_hi;		/* last byte of allocated */
  machine next;		/* linked list of unused ones */
  machine prev;		/* and doubly linked list of used ones */

  /* from here on down is architecture specific */

  int energy;		/* current energy level */
  int acc;		/* accumulator */
  int regs[4];		/* the registers */
  int returnaddr;	/* return address; -1 = error */
};

