/* declarations for the sierra system */

typedef int boolean;
#define true (1)
#define false (0)

extern char *memory;	/* this is the main memory (soup) */
extern int membytes;	/* size of the soup */

extern int universal;	/* universal time in number of machine ops */

extern boolean sierra_debug;
extern boolean sierra_zerodealloc;

extern machine machine_ring;	/* ring of all machines that can run */


#define RAND_MASK 0x3FFFFFFF

/****************************************************************************
 *** procedures that are in random.c
 ***************************************************************************/

extern void set_seed (int seed);
extern int genrandom ();


/****************************************************************************
 *** procedures that are in sierra.c
 ***************************************************************************/

extern boolean allocate_memory (int address, int numbytes);
extern void deallocate_memory (int address, int numbytes);
extern int retrieve_genome (int address, int bytes, int parentid);
extern void create_machine (int pc, int address, int len, int pargenid);
extern void kill_machine (machine machine);
extern void init_sierra (int fellsize, int memorysize);


/****************************************************************************
 *** procedures that must be supplied by the architecture
 ***************************************************************************/

extern void print_code (int bytes, char *code);
extern void init_machine (machine new, int len);
extern int run_machine (int count);
extern char *ancestor_code ();
extern void init_architecture ();
extern void set_parameters (int copyerrors, int cosmicerrors);
extern void errors (int);
