;;; this is the startup file for FELL.

;;; it defines a number of parts of the language in a smaller subset of it

(defmacro cond (&rest forms)
  (if (null forms)
      '()
    `(if ,(first (first forms)) (progn ,@(rest (first forms))) (cond ,@(rest forms)))))


(defmacro do (argforms endtest &rest forms)
  (let ((argnames (mapcar #'first argforms))
	(inits (mapcar #'second argforms))
	(steps (mapcar #'third argforms))
	(varname (gensym)))
    `(block ()
       (let ,(mapcar #'list argnames inits)
	 (tagbody
	  ,varname
	  (if ,(first endtest) (return (progn ,@(rest endtest))))
	  ,@forms
	  (let ((,varname (list ,@steps)))
	    ,@(mapcar #'(lambda (argname) `(progn (setq ,argname (first ,varname))
						  (setq ,varname (rest ,varname))))
		      argnames))
	  (go ,varname))))))

(defmacro setf (place value)
  (if (symbolp place)
      `(setq ,place ,value)
    (if (consp place)
	(let ((accessor (first place)))
	  ;(format t "~%Hooley dooley:~%")
	  ;(format t "~%Holy moly:~%")
	  (if (memq accessor '(car first))
	      `(%%setcar ,(second place) ,value)
	    (if (memq accessor '(cdr rest))
		`(%%setcdr ,(second place) ,value)
	      (if (eq accessor 'svref)
		  `(svset ,(second place) ,(third place) ,value)
		(if (eq accessor 'second)
		    `(%%setcar (cdr ,(second place)) ,value)
		  (if (eq accessor 'third)
		      `(%%setcar (cdr (cdr ,(second plave))) ,value)
		    (error "Unknown setf place: ~S" place)))))))
      (error "Unknown setf place: ~S" place))))

(format t "  ... loaded startup.lisp")


